// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

// #define ff f.f
// #define fs f.s
// #define sf s.f
// #define ss s.s

const ll INF = (ll) (1e9);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"


#define pb push_back
#define eb emplace_back

// #define M_PI 3.1415926535

// #pragma GCC optimize("unroll-loops")
// #pragma GCC ognome-terminalptimize("Ofast")
// #pragma GCC optimize("no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
// #pragma GCC optimize("fast-math")
// #pragma GCC optimize "-O3"

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 13) ^ rand();
}


vector < vector < Pll > > graph;
vector < Pll > edge;
vector < bool > used;
void dfs(ll node, ll id){
   used[node] = true;
   for(auto to : graph[node]){
      if(!used[to.f] and to.s != id)
         dfs(to.f, id);
   }
}

void solve() {
   ll n, m;
   cin >> n >> m;

   used.assign(n, false);
   graph.assign(n, {});
   edge.assign(m, {0, 0});

   for(int i = 0; i < m; ++i){
      cin >> edge[i].f >> edge[i].s;
      --edge[i].f, -- edge[i].s;

      graph[edge[i].f].pb({edge[i].s, i});
      graph[edge[i].s].pb({edge[i].f, i});
   }

   vector < ll > ans;
   for(int i = 0; i < m; ++i){
      used.assign(n, false);
      dfs(0, i);
      bool flag = true;
      for(auto i : used)
         flag &= i;
      if(!flag)
         ans.pb(i);
   }  

   cout << len(ans);
   return;
}

int main() {
   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}