#include <iostream>
#include <vector>
#define ii pair<int,int>
#define x first
#define y second
using namespace std;

vector<vector<int>> g;
void dfs(int i, vector<bool> &visited, int target=-1){
    visited[i]=true;
    for(auto u:g[i]){
        if(!visited[u]&&u!=target){
            dfs(u,visited);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    vector<ii> e(m);
    g.resize(n+1);
    for(int i=0; i<m; i++){
        cin>>e[i].x>>e[i].y;
        g[e[i].x].push_back(e[i].y);
        g[e[i].y].push_back(e[i].x);
    }
    int count=0;
    for(auto ec: e){
        vector<bool> visited(n+1,false);
        dfs(ec.x,visited,ec.y);
        if(!visited[ec.y]){
            count++;
        }
    }
    cout<<count;
    return 0;
}
