#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>

using namespace std;
#define fr(i, n) for(int  i = 0; i < n; i++)
typedef vector<int> vi;
typedef vector<list<int>> gph;

int N, M;

gph graph;
vi inTime;

vi haveBenn;
int counter = 0;
int dfs(int node, int& nowTIme, int parent)
{
	int original = inTime[node] = nowTIme++;
	haveBenn[node] = 1;
	for (int curr : graph[node])
	{
		if (curr == parent)
		{
			continue;//back in tree
		}

		if (!haveBenn[curr])//tree node
		{
			inTime[node] = min(dfs(curr, nowTIme, node), inTime[node]);
		}
		else
		{
			inTime[node] = min(inTime[curr], inTime[node]);
		}
	}
	if (original == inTime[node])
	{
		counter++;
	}
	return inTime[node];
}


int main()
{
	int a, b;
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> N >> M;
	inTime.resize(N);
	graph.resize(N);
	fr(i, M)
	{
		cin >> a >> b;
		a--; b--;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	haveBenn.resize(N, 0);
	a = 0;
	dfs(0, a, 0);
	cout << counter - 1<< endl;
	return 0;
}