#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

using pii = pair<int, int>;

const int maxV = 602, maxE = 2003;
int N, M;
vector<int> G[maxV];
pii edges[maxE];
bool used[maxV];

bool dfs(int v, int s, int t)
{
    used[v] = true;
    if (v == t)
        return true;
    for (auto &u : G[v])
        if (!used[u] && !(v == s && u == t))
            if (dfs(u, s, t))
                return true;
    return false;
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> N >> M;
    for (int i = 0; i < M; ++i)
    {
        cin >> edges[i].fi >> edges[i].se;
        G[edges[i].fi].push_back(edges[i].se);
        G[edges[i].se].push_back(edges[i].fi);
    }
    int cnt = 0;
    for (int i = 0; i < M; ++i)
    {
        fill(used, used + N + 1, 0);
        if (!dfs(edges[i].fi, edges[i].fi, edges[i].se))
        {
            ++cnt;
        }
    }
    cout << cnt << '\n';

    return 0;
}
