#include <iostream>
#include <vector>
#include <set>

#define ll long long
#define vll vector<ll>
#define sll set<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vb vector<bool>

using namespace std;

ll n, m;
vvll graph;

ll dfs(ll cur, vb& vis, pll &bad)
{
	ll curans = 1;
	vis[cur] = true;
	for (ll i = 0; i < graph[cur].size(); i++)
	{
		ll nei = graph[cur][i];
		if (nei == bad.first && cur == bad.second) continue;
		if (nei == bad.second && cur == bad.first) continue;
		if (vis[nei]) continue;
		curans += dfs(nei, vis, bad);
	}
	return curans;
}

int main()
{
	cin >> n >> m;
	vector<pll> e(m);
	graph.resize(n);
	for (ll i = 0; i < m; i++)
	{
		ll x, y;
		cin >> x >> y;
		x--, y--;
		e[i] = { x, y };
		graph[x].push_back(y);
		graph[y].push_back(x);
	}
	ll ans = 0;
	for (ll i = 0; i < m; i++)
	{
		vb curvis(n, 0);
		//cout << "cur e: " << e[i].first << " " << e[i].second << endl;
		if (dfs((ll)0, curvis, e[i]) < n) ans++;
	}
	cout << ans << endl;
}
