#include <unordered_set>
#include "guess.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <queue>
#include <set>
#include <map>
using namespace std;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
    return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(a)
#endif
using llong = long long;
using uint = unsigned int;
using ullong = unsigned long long;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

int find_number(int r)
{
    int l = 1, ans = -1;
    while (l <= r)
    {
        int m = l + (r - l) / 2;
        if (smaller(m))
            r = m - 1;
        else {
            ans = m;
            l = m + 1;
        }
    }
    return ans;
}
