#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
#define pll pair<ll, ll>
#define pb push_back

const ll maxn = ll(1e4) + 5;

ll n, m;
vector<ll> gr[maxn];

ll tin[maxn], up[maxn], t = 1;

ll ans = 0;

vector<ll> used;

void dfs(ll v, ll par) {
    tin[v] = ++t;
    up[v] = tin[v];
    used[v] = true;

    for(auto i : gr[v]) {
        if(i == par) continue;
        if(used[i]) {
            up[v] = min(up[v], tin[i]);
        } else {
            dfs(i, v);
            if(up[i] > tin[v]) {
                ans++;
            }
            up[v] = min(up[v], up[i]);
        }
    }
}

void solve() {
    cin >> n >> m;
    for(ll i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        gr[v].pb(u);
        gr[u].pb(v);
    }

    used.assign(n, 0);
    for(ll i = 0; i < n; i++) {
        if(!used[i]) {
            dfs(i, -1);
        }
    }

    cout << ans << "\n";
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
