#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <functional>
#include <limits>
#include <ctime>
#include <random>
#include <bitset>
#include <numeric>
#include <complex>

#define pb push_back
#define mp make_pair
#define endl '\n'
#define sqr(x) ((x) * (x))
#define IOboost ios_base::sync_with_stdio(false); cin.tie(NULL)
//#define int ll

//#ifndef LOCALFILE
//#define _getchar_nolock getchar_unlocked
//#define _putchar_nolock putchar_unlocked
//#endif

#pragma warning(disable : 4996)
#pragma optimize("gtsy", on)
//#pragma comment(linker, "/STACK:16777216")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int cnt = 0;

void dfs(int v, vector<vector<int>>& a, vector<int>& d, vector<int>& up, int p = -1) {
	if (p == -1)
		d[v] = 0;
	else
		d[v] = d[p] + 1;
	up[v] = d[v];
	for (int u : a[v]) {
		if (u == p)
			continue;
		if (d[u] == -1) {
			dfs(u, a, d, up, v);
			up[v] = min(up[v], up[u]);
		}
		else {
			up[v] = min(up[v], d[u]);
		}
	}
	if (p!= -1 && up[v] >= d[v])
		++cnt;
	return;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	IOboost;

	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		a[u].push_back(v);
		a[v].push_back(u);
	}
	vector<int> d(n, -1), up(n);
	dfs(0, a, d, up);
	cout << cnt;

	return 0;
}