#include <bits/stdc++.h>

#define int long long
using namespace std;
const int maxn = 600;
vector<int> g[maxn];
int timer = 0;
int tin[maxn];
int fup[maxn];
bool used[maxn];
int ans = 0;

void dfs(int v, int p) {
    tin[v] = timer++;
    fup[v] = tin[v];
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (to == p)continue;
        if (used[to]) {
            fup[v] = min(fup[v], tin[to]);
        } else {
            dfs(to, v);
            fup[v] = min(fup[v], fup[to]);
        }
        if (fup[to] > tin[v]) {
            ans++;
        }
    }
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    set<pair<int, int>> st;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (a > b)swap(a, b);
        if (st.count({a, b}) == 1)continue;
        st.insert({a, b});
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, -1);
    cout << ans;
}