#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define fs first
#define sc second

int snm[1000], kol[1000];

int get(int x){
    if(x == snm[x]) return x;
    return snm[x] = get(snm[x]);
}

void merge(int x, int y){
    x = get(x); y = get(y);
    if(x == y) return;
    if(kol[x] < kol[y]) swap(x, y);
    snm[y] = x;
    kol[x] += kol[y];
}

int main()
{
   // ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int> > ed(m);
    for(int i = 0; i < m; i++){
        cin >> ed[i].fs >> ed[i].sc;
        ed[i].fs--;
        ed[i].sc--;
    }

    int ans = 0;

    for(int j = 0; j < m; j++){
        for(int i = 0; i < n; i++){
            snm[i] = i;
            kol[i] = 1;
        }
        for(int o = 0; o < j; o++){
            merge(ed[o].fs, ed[o].sc);
        }
        for(int o = j+1; o < m; o++){
            merge(ed[o].fs, ed[o].sc);
        }

        if(get(ed[j].fs) != get(ed[j].sc)){
            ans++;
        }
    }

    cout << ans;

}
