#include <vector>
#include <iostream>
using namespace std;


vector<vector<pair<int, int>>> adj;
pair<int, int> roads[2000];
bool done[600];
int n, m;

bool chack(int x, int no, int to) {
    if (x == to)
        return true;
    if (done[x])
        return false;
    done[x] = true;
    for (auto u : adj[x]) {
        if (u.second != no && !done[u.first]) {
            if (chack(u.first, no, to))
                return true;
        }
    }
    return false;
}

int main()
{
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        adj.push_back(vector<pair<int, int>>());
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        adj[a - 1].push_back({ b - 1, i });
        adj[b - 1].push_back({ a - 1, i });
        roads[i] = { a - 1, b - 1 };
    }
    int count = 0;
    for (int i = 0; i < m; i++) {
        if (!chack(roads[i].first, i, roads[i].second))
            count++;
        bool f = false;
        for (int j = 0; j < n; j++) {
            done[j] = false;
        }
    }
    cout << count << endl;
}
