/*
																							  
																							  
										..........             ...........  ..  ..          
	 ..--.............  ...................----......... ...........--......------.         
	  ..::----------------::---.-:*:::::*:*******:::***:-:::::----............-**..         
	  ..-:::-................:::****:--..-:--:::-..:**-::-..................:**:-.          
	   ...-::::..........-*:--.-::-:-.....-:.-..-::-..--.....--..........-::::--..          
	  ...-..-*::::-....:*--...----:--......-:.--..-::...--....-----...-:::::-..-..          
		.-...-*::--:**:.-...-:..-:--.......-:-..-...::-...-.....-:--:::::::-....            
		....-...-::::......--...-.*-........::-.--...-:-...-.-...----:::...-..-.            
		..---...-:*.......--...---*-........-:-..-....-::...---...--:-::-...-.-.            
		  .--..-::..-....--...-:.::-........-::..--....-*:..-.:-...--:-:::-.--..            
		  .--.:*-..-....-:....--.::-........-:*-..:--...:*-..--*-...--::**:-.-..            
		  ...:+-..-.....:....-:.-::-....-...-:*:..:-.-..-:*..-.*:....--:****:-..            
		  ..-+-..-...-..:...--:.:::-....--...::*..-:-.--.:::.--*::...---::-:*...            
		  ..*....-..-..--...-::.::*-.....-.-.*:*-.-:---:-::*--::.::...---:--::.             
		  .--.-.-..--..--..--::.*:*--....:.:-*:::.-::---*-::*-*..:::..----:--+..            
		  .-.:..-..--..--..-:::-*:::-....:.-*::.*.---:--:*::-*-..-:::..---:--*-.            
		..--:-.-...--..--..-::::*::*:-...:--*:-.:.--.-:--*:::*....::::.-------*.            
		..:-*..-..-::..:----:--:*-:*::...---*:-.:-::..-:::*::*-...-::::.------:.            
		.--:*.-..--::..:---::..::--:*:-..---**-.----...-:::::::...-::-::------:.            
		.--:*.-..--::..:--::-..-:-.-*:------:*-.--:.....::::--:-..-::--:*------.            
	   ..--:*.-..--:*..:--::-...::..-:------::..--:...--::-::-:...-::---:*:---:-.           
	   .--.:*--.---::-.:--::-..--:-..-:----:-:..-::-+%####%@@**-..-::---.*::----..          
	   .--.:::-.---:::.:--::+=%%%=*--.-:---:.-..-:**%#####@-::*+-.-::--:.::::----.          
	  ..--.::*-.:--:::--:*%##@@@#+**-...-:--....:--*@#@#@#%=:+::-.-::--:.::::::--..         
	  ..--.-::-.---::*:-*::#####@=+%:-...--.....-...=+++**=*+*--..-::--:--*:---*---...      
	   ..-.-::-.---::::::-:+=++=++*++...............-=:::::*+.:...-::--*:-*::-.---....      
		...--::.----::*::--.+****::+:.................-:--:---:.-.-::--**.**:-..--....      
		...---:-.:--:-:*:::-.-**:::--...................---------.-::..+*.**:-..--.         
		  .---::.---::::*::-------......................-----:-:..:::..++.::*:...--.        
		  .---::--:-::-::*::-----........................---:-:*..**:.-=+.::**-..--..       
		  .:-.::*.:--:-:::=+:--...........................-:--=*.-**-.-==-::***-..--..      
		  .:..--:*.:-*::::*=*::-.........................-.-*+=*.***--:=+-:::**:-...-.      
		  .-..-::*+-*:*:-::==*-.---..........:-..........:=***=*:**:.-*=*.*:::**:..--..     
		..-...-::++*:**:-::+=**++:....................:=++=***=***:-.:+=:.+*:::*:*----..    
		.-....-:***+:*:*:::+=+*+++*+=*-............:*:=**+=***=***:.::++:.++:-:-:::-.--...  
	   ..-....-*+**+*:**:::*=+*+++**+=+=:*::...-:*::::=***+=**:--::=*:-+++:::-:*-----..  
	  ..-....--+***+=:::**::++*+++**+%+==*::::::**+=%%%+**=+*+=*:-:::++*.*+*+*::---*..:---..
	 ..-....--+****==+-::*::*=+++=***=+=########@@%%%%@%+*++*++*::-:*=+:-=+**+*::---:..-:--.
	..-...--.*****+=++:------:+++=%@@@##%@####@@%%%%=+:%@%%@#@*:::::=++.*+***++:::----..-:--
   ..--..-:.**:*:..........-=@@%@@@%%@*:::---*:--:------*%%%@+:::-:=#+.***+***++::---:-..-:*
  ...-..-:-:+::-........-*@@@@=+*%##@%+:----**:---------*%%@=*::-:++:**:::::***++::---:...:-
  ..-..::--=::-.......-:@@%%=:*+%*:-%%=:..--**:**-:-....=@@=%@##@%%=::-......-*+++::---:..-:
...-..:::-*+::.......-=%%%%:+*%*:--..:%:.....-:*:-....--**%@+*+%%%%%@=::-.......-++::--:-..:
..-..::---=*:-......-=%%%%*+=%::-..-...=.............-....--:%***%%%@##**:........:*:---:..:
.-..-----*+::-.....--#@%%=+*@::--....:*@%=+***+*****:..-...---:%*++%%%%@+*........--*-----.:
-..----:-++*:-------*####%@@%:-..--..=#%@%%%%%@==%%%..-...--.---+=**%%%%@+..........::---:.:
..-.----:=***:::::::*####%%#+::-...:@@@%%@@%%%:%=-%%@-:..--..----+%*+@%%@+...........*---:-:
.-.-----*=*-*::::::::####%%#:--.-++*=%%@%%#@%%@**%%%@@#*-:..-:.---=%=@##@*---.......-:----::
-..---:-+=*.-=:::::::@##@@%##@+***::=@%%%%%#=+%:*%+=@@%=****-.*%####%%#%+*--------.---:---*-
...:--::*=*.-********:::::*+++:::*::+%==%%@%@@:-:+%@@%=+*:::**++*=%%+=+-..:*******---:*---*-
 .----:**=*..:*:---------:**:*:-:*::+@@%%%===%#@@@@=*+:+*::::+:-----*+:-...........--:::--*-
..----:**=*..::*---------:+*::*-:*::+::*=@@#@%%@##%@##@%*:-::+:-----:**--.........-:::.:-:::
..----:+*=*..::::--------:=:-**-:*:*+-----:+=@@@@@@%=*--*::::*:----:-:*-----...--:::....:*:-
*/
  
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
 // #pragma GCC optimization("O2")
// #pragma GCC optimization
// #pragma GCC optimization("avx")
// #pragma GCC optimization("avx2")

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2")

// 8x = Ofast, avx, avx2, fma

// #pragma GCC target ("avx,avx2,fma")
// #pragma GCC optimize ("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;
mt19937 rnd(time(0));
typedef long long ll;
typedef long double ld;

// #define _GLIBCXX_DEBUG
// #define int ll
#define f first
#define s second
#define pb push_back
#define int ll
#define pii pair<int, int> 
#define vi vector<int>

const int mod = 1e9 + 9;

void solve() {
	int k;
	cin >> k;
	int a[k];
	for (auto &i : a)
		cin >> i;
	map<int, int> mp;
	for (int i = 0; i < k; ++i) {
		map<int, int> mp2;
		for (int j = 0; j < a[i]; ++j) {
			int x;
			cin >> x;
			mp2[x]++;
		}
		for (auto &i : mp2)
			mp[i.f]++;
	}
	int ans = 1e9;
	for (auto &i : mp) {
		if (i.s == k)
			ans = min(ans, i.f);
	}
	cout << ans << "\n";
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	// cin >> t;
	while(t--){
		solve();
	}

	return 0;
}