#include <bits/stdc++.h>
#define LL long long
#define LD long double
#define INF (1<<28)
using namespace std;

const int maxN = 600, maxM = 2000;
int N, M;
vector < vector<int> > adj(maxN);
int dfsIdx[maxN], dfsNum[maxN];
int nextIdx = 1;

void DFS( int V, int p ){

    if( dfsIdx[V] != -1 ) return;

    dfsIdx[V] = dfsNum[V] = nextIdx++;

    for( int _V : adj[V] ){

        if( _V == p ) continue;

        if( dfsIdx[_V] == -1 ) DFS( _V, V );
        dfsNum[V] = min( dfsNum[V], dfsNum[_V] );

    }

}

int main(){ iostream::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    memset( dfsIdx, -1, sizeof dfsIdx );
    memset( dfsNum, -1, sizeof dfsNum );

    cin >> N >> M;

    int x, y;
    for(int i=0;i<M;i++){
        cin >> x >> y;
        adj[x].push_back(y);
        adj[y].push_back(x);
    }

    DFS( 1, 1 );

    set <int> ST;

    for(int i=1;i<=N;i++){
        // cout << i << ' ' << dfsIdx[i] << ' ' << dfsNum[i] << endl;
        ST.insert( dfsNum[i] );
    }

    cout << ST.size()-1 << endl;

}
