#include <bits/stdc++.h>

#define int long long
#define all(v) v.begin(), v.end()

using namespace std;


const int maxn = 600;
const int maxm = 2000;


vector<int> graph[maxn];
bool was[maxn];

void dfs(int v, pair<int, int> &e){
    was[v] = true;
    for(int u: graph[v]) {
        if(!was[u] && make_pair(v, u) != e && make_pair(u, v) != e){
            dfs(u, e);
        }
    }
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> edges;
    for(int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        --a, --b;
        graph[a].push_back(b);
        graph[b].push_back(a);
        edges.emplace_back(a, b);
    }
    int cnt = 0;
    for(auto e: edges){
        dfs(0, e);
        bool bridge = false;
        for(int i = 0; i < n; ++i){
            if(!was[i]) {
                bridge = true;
            }
            was[i] = false;
        }
        cnt += bridge;
    }
    cout << cnt;
}