#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

const int inf = 1e9 + 7;
const int N = 1e5 + 1;
vector <int> gr[N];
int used[N];
int tin[N];
int timer = 0;
int fup[N];
int ans = 0;

void dfs(int v, int pr = -1) {
    used[v] = 1;
    fup[v] = tin[v] = timer++;
    for (auto it : gr[v]) {
        if (it == pr) continue;
        if (used[it]) fup[v] = min(fup[v], tin[it]);
        else {
            dfs(it, v);
            fup[v] = min(fup[v], fup[it]);
        }
    }
    for (auto it : gr[v]) {
        if (it == pr) continue;
        if (fup[it] <= tin[v]);
        else ans++;
    }
}

signed main () {
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    cout << ans << '\n';
    return 0;
}




















