#include <bits/stdc++.h>
using namespace std;

const int N = (int)(10);

int n, m;
int x[N], y[N];
vector <int> g[N];
bool was[N], mk[N];

void dfs(int v, int pr = -1) {
    if (was[v]) {
        return;
    }
    was[v] = 1;
    for (int u : g[v]) {
        if (u == pr) {
            continue;
        }
        if (mk[u] && mk[v]) {
            continue;
        }
        dfs(u, v);
    }
}

bool bad(int _x, int _y) {
    mk[_x] = mk[_y] = 1;
    for (int i = 0; i < n; ++i) {
        was[i] = 0;
    }
    dfs(0);
    mk[_x] = mk[_y] = 0;

    bool gd = 1;
    for (int i = 0; i < n; ++i) {
        gd &= (was[i]);
    }
    return !gd;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> x[i] >> y[i];
        --x[i], --y[i];
        g[x[i]].push_back(y[i]);
        g[y[i]].push_back(x[i]);
    }

    int ans = 0;
    for (int i = 0; i < m; ++i) {
        ans += bad(x[i], y[i]);
    }

    cout << ans << "\n";
}
