#include <bits/stdc++.h>
using namespace std;

const int N = (int)(1e5 + 500);

int n, m, cnt;
int x[N], y[N], tot[N];
vector <int> g[N];
bool was[N], mk[N];
vector <int> ord;

void dfs(int v, int pr = -1) {
    if (was[v]) {
        return;
    }
    ++cnt;
    was[v] = 1;
    for (int u : g[v]) {
        if (u == pr) {
            continue;
        }
        if (mk[u] && mk[v]) {
            continue;
        }
        dfs(u, v);
    }
}

void rec(int v, int pr, int fx) {
    if (was[v]) {
        return;
    }

    ++tot[fx];
    was[v] = 1;
    for (int u : g[v]) {
        rec(u, v, fx);
    }
}

bool bad(int _x, int _y) {
    mk[_x] = mk[_y] = 1;
    for (int i = 0; i < n; ++i) {
        was[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        if (was[i]) {
            continue;
        }

        cnt = 0;
        dfs(i);

        if (cnt != tot[i]) {
            mk[_x] = mk[_y] = 0;
            return 1;
        }
    }
    mk[_x] = mk[_y] = 0;

    return 0;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> x[i] >> y[i];
        --x[i], --y[i];
        g[x[i]].push_back(y[i]);
        g[y[i]].push_back(x[i]);
    }

    for (int i = 0; i < n; ++i) {
        if (was[i]) {
            continue;
        }
        rec(i, -1, i);
    }

    int ans = 0;
    for (int i = 0; i < m; ++i) {
        cerr << "ok\n";
        ans += bad(x[i], y[i]);
    }

    cout << ans << "\n";
}
