#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

const int N = 700;

int n, m, tin[N], fup[N], timer;
vector < int > a[N];
set < pair < int, int > > se;
bool used[N];

void dfs(int v, int p) {
    used[v] = true;
    fup[v] = timer;
    tin[v] = timer++;
    for (int i = 0; i < a[v].size(); i++) {
        int to = a[v][i];
        if (to == p) continue;
        if (used[to]) {
            fup[v] = min(fup[v], tin[to]);
        } else {
            dfs(to, v);
            fup[v] = min(fup[v], fup[to]);
            if (fup[to] > tin[v]) {
                se.insert({v, to});
                se.insert({to, v});
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int f, s;
        cin >> f >> s;
        f--, s--;
        a[f].push_back(s);
        a[s].push_back(f);
    }
    dfs(0, -1);
    cout << se.size() / 2;
}
