#include <iostream>
#include <set>
#include <map>

#define ll int

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optmize("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

using namespace std;
const ll inf = (ll)2e9;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

    map <ll,ll> kol;
    ll k;

    cin >> k;
    ll len[k];
    for (ll i = 0; i < k; ++i)
        cin >> len[i];

    set <ll> s;
    ll x;
    for (ll i = 0; i < k; ++i) {
        for (ll j = 0; j < len[i]; ++j) {
            cin >> x;
            s.insert(x);
        }
        for (auto xx: s)
            ++kol[xx];
        s.clear();
    }
    ll ans = inf;
    for (auto i: kol) {
        if (i.second == k)
            ans = min(ans,i.first);
    }

    if (ans == inf) {
        cout << 'x';
    }
    else {
        cout << ans;
    }
    return 0;
}
