#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()

void dfs(int v, int p, vector<int> &in, vector<int> &out, vector<int> &up, vector<vector<int> > &g, int &T)
{
    in[v] = up[v] = T++;
    for (auto u : g[v])
    {
        if (in[u] == 0)
        {
            dfs(u, v, in, out, up, g, T);
            up[v] = min(up[v], up[u]);
        }
        else if (u != p)
        {
            up[v] = min(up[v], up[u]);
        }
    }
    out[v] = T++;
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int> > g(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int> up(n), out(n), in(n);
    int T = 1;
    for (int i = 0; i < n; i++)
    {
        if (in[i] == 0)
        {
            dfs(i, i, in, out, up, g, T);
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (auto to : g[i])
        {
            if (in[i] <= in[to] && out[to] <= out[i])
            {
                if (up[to] == in[to])
                    ans++;
            }
        }
    }
    cout << ans;
}
