#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define int long long
#define mp make_pair
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long double db;
typedef pair < int, int > pii;
typedef long long ll;

const int N = 1e3 + 5;
vector < int > gr[N];
int lev[N];
int dp[N];
int ans = 0;
int C = 1;

void dfs(int v, int p = 0) {
    lev[v] = C++;
    dp[v] = lev[v];
    for (auto u : gr[v]) {
        if (u == p) {
            continue;
        }
        if (!lev[u]) {
            dfs(u, v);
            if (dp[u] > lev[v]) {
                ans++;
            }
            dp[v] = min(dp[v], dp[u]);
        } else {
            dp[v] = min(dp[v], lev[u]);
        }
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        gr[v].pb(u);
        gr[u].pb(v);
    }
    dfs(0);
    cout << ans;
    return 0;
}
