#include <iostream>
#include <sstream>
#include <cstdio>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <unordered_map>
using namespace std;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2 &y) {if (x > y) {x = y; return true;} return false;}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2 &y) {if (x < y) {x = y; return true;} return false;}
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
using ll = long long;
using ld = long double;
const int MAXN = 1005;


int n, m;
vector<int> g[MAXN];
bool used[MAXN];
int ans = 0;
int timer = 0;
int in[MAXN];
int fup[MAXN];


void dfs(int u, int pr = -1) {
 	used[u] = true;
 	in[u] = fup[u] = timer++;
	for (auto h: g[u]) {
		if (h == pr) {
			continue;
		}
		if (!used[h]) {
			dfs(h, u);
			chkmin(fup[u], fup[h]);
			if (fup[h] > in[u]) {
				ans++;
			}
		} else {
			chkmin(fup[u], in[h]);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int it = 0; it < m; it++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].pb(b);
		g[b].pb(a);
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	cout << ans << '\n';
}