#include <bits/stdc++.h>
using namespace std;

vector<pair<int, int>> edges;

vector<vector<int>> g;

vector<int> used;

void dfs(int v, int no) {
    used[v] = 1;
    for (int e : g[v]) {
        if (e == no)
            continue;
        int u = edges[e].first + edges[e].second - v;
        if (!used[u])
            dfs(u, no);
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(edges.size());
        g[b].push_back(edges.size());
        edges.push_back({a, b});
    }
    int ans = 0;
    int cnt;

    {
        cnt = 0;
        used.assign(n, 0);
        for (int u = 0; u < n; u++) {
            if (!used[u])
                cnt++, dfs(u, -1);
        }
    }
    int init_cnt = cnt;
    for (int i = 0; i < m; i++) {
        {
            cnt = 0;
            used.assign(n, 0);
            for (int u = 0; u < n; u++) {
                if (!used[u])
                    cnt++, dfs(u, i);
            }
        }
        if (cnt != init_cnt)
            ans++;
    }
    cout << ans << endl;
}

