#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a.begin()), (a.end())
#define endl "\n"
#pragma GCC optimize('O3')

using namespace std;

const int N = 1e6 + 10;
const int inf = 1e10;

int n, m;
vector<int> g[N];
bool used[N];

void dfs(int v)
{
	used[v] = true;

	for (auto u : g[v])
		if (!used[u])
			dfs(u);
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> m;

	for (int i = 0; i < m; ++i)
	{
		int v, u;
		cin >> v >> u;
		--v; --u;

		g[v].push_back(u);
		g[u].push_back(v);
	}

	int ans = 0;

	for (int i = 0; i < n; ++i)
		if (!used[i])
		{
			dfs(i);
			++ans;
		}

	cout << ans << endl;
}

