#include <bits/stdc++.h>
using namespace std;

#define    pb        push_back
#define    ll        long long
#define  sz(a)       (int)a.size()
#define all(a)       a.begin(),a.end()
#define rall(a)      a.rbegin(),a.rend()
#define  fastio      ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);


int main()
{
    fastio;
    int n,m;
    cin >> n >> m;
    vector<int> adj[n];
    vector<pair<int,int>> edges;
    for(int i= 0;i < m;i++)
    {
        int x,y;
        cin >> x >> y;
        x--,y--;
        adj[x].pb(y);
        adj[y].pb(x);
        edges.pb({x,y});
    }
    int ans = 0;
    for(int i = 0;i < m;i++){
        bool vis[n];
        for(int j= 0;j < n;j++)
            vis[j] = false;

        int a = edges[i].first, b = edges[i].second;
        for(int j = 0;j < sz(adj[a]);j++){
            if(adj[a][j] == b){
                adj[a].erase(adj[a].begin() + j);
            }
        }
        for(int j = 0;j < sz(adj[b]);j++){
            if(adj[b][j] == a){
                adj[b].erase(adj[b].begin() + j);
            }
        }


        queue<int> q;
        vis[a] = true;
        q.push(a);
        while(!q.empty())
        {
            int u = q.front();
            q.pop();
            for(auto x : adj[u])
            {
                if(!vis[x]){
                    q.push(x);
                    vis[x] = true;
                }
            }
        }
        if(!vis[b])++ans;
        adj[b].pb(a);
        adj[a].pb(b);
    }
    cout << ans;
}
