#include <bits/stdc++.h>
#include <unordered_map>
using namespace std;

using ll = long long;
#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
vector <pair <int, int>> edges;
const int N = 600;
vector <int> gr[1 + N];
int used[1 + N];
void dfs (int node) {
    used[node] = true;
    for (int vec : gr[node])
        if (not used[vec])
            dfs (vec);
}
int n, m;
int solve (int index) {
    for (int i = 1; i <= n; i++)
        gr[i].clear (), used[i] = false;
    for (int i = 0; i < m; i++)
        if (i != index) {
            gr[edges[i].first].pb (edges[i].second);
            gr[edges[i].second].pb (edges[i].first);
        }
    int nr = 0;
    for (int i = 1; i <= n; i++)
        if (not used[i]) {
            nr++;
            dfs (i);
        }
    return nr;
}
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        edges.pb ({x, y});
    }
    int in = solve (-1);
    int ans = 0;
    for (int i = 0; i < m; i++) {
        int nr = solve (i);
        if (nr != in) ans++;
    }
    cout << ans << "\n";
    return 0;
}
