#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 602;

int n, m;
int vis[MAXN], mint[MAXN];
int timer = 0, ans = 0;
vector<int> g[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void DFS(int u, int p = 0)
{
    vis[u] = ++timer;
    mint[u] = vis[u];

    int reach = MAXN;
    for (int v : g[u])
    {
        if (v == p) continue;
        if (vis[v] == 0)
        {
            DFS(v, u);
            mint[u] = min(mint[u], mint[v]);
        }
        else mint[u] = min(mint[u], vis[v]);
    }

    if (mint[u] == vis[u]) ans++;
    //cout << u << ' ' << vis[u] << ' ' << mint[u] << endl;
}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        if (vis[i] == 0)
        {
            DFS(i);
            ans--;
        }
    }
    cout << ans << endl;
    return 0;
}
