#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1003;

int n, k[MAXN];
vector<int> v[MAXN];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int idx = 1;

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> k[i];
        if (k[i] < k[idx]) idx = i;
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= k[i]; ++ j)
        {
            int x;
            cin >> x;
            v[i].push_back(x);
        }
        sort(v[i].begin(), v[i].end());
    }

    for (int i = 0; i < k[idx]; ++ i)
    {
        bool miss = false;
        for (int j = 1; j <= n; ++ j)
        {
            int l = 0, r = v[j].size() - 1, res = 0;
            while (l <= r)
            {
                int mid = (l + r) / 2;
                if (v[j][mid] == v[idx][i])
                {
                    res = 1;
                    break;
                }
                if (v[j][mid] < v[idx][i]) l = mid + 1;
                if (v[j][mid] > v[idx][i]) r = mid - 1;
            }
            if (res == 0)
            {
                miss = true;
                break;
            }
        }

        if (!miss)
        {
            cout << v[idx][i] << endl;
            return 0;
        }
    }

    cout << 'x' << endl;
    return 0;
}
