#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 610;
vector<int> dp(MAX_N);
vector<int> depth(MAX_N);
vector< vector<int> > adj(MAX_N);
int br = 0;
void dfs(int cur)
{
    dp[cur] = 0;
    for(auto x : adj[cur])
    {
        if(depth[x] == 0)
        {
            depth[x] = depth[cur] + 1;
            dfs(x);
            dp[cur] += dp[x];
        }
        else if(depth[x] < depth[cur]) dp[cur]++;
        else if(depth[x] > depth[cur]) dp[cur]--;
    }
    dp[cur]--;
    if(depth[cur] > 1 && dp[cur] == 0)
    {
        br++;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m;
    int u0,v0;
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        cin>>u0>>v0;
        adj[u0].push_back(v0);
        adj[v0].push_back(u0);
    }
    for(int i=1; i<=n; i++)
    {
        if(depth[i] == 0)
        {
            depth[i] = 1;
            dfs(i);
        }
    }
    cout<<br<<endl;
}
