#include<bits/stdc++.h>
#define eb push_back
#define pb push_back

using namespace std;

const int MAXN = 600;
int n, m;
vector<int> con[MAXN];
bool used[MAXN];
int depth[MAXN], mn[MAXN];
int roads;

void input() {
    cin>>n>>m;

    int a, b;
    for (int i=0; i<m; i++) {
        cin>>a>>b;
        con[a-1].pb(b-1);
        con[b-1].pb(a-1);
    }
}

void output() {
    cout<<roads<<endl;
}

void dfs(int curr, int par, int d) {
    //cerr<<"enter "<<curr<<' '<<par<<' '<<d<<endl;
    used[curr] = 1;
    depth[curr] = d;
    mn[curr] = d;

    for (int ch : con[curr]) {
        if (ch == par) {
            continue;
        }
        if (used[ch]) {
            mn[curr] = min(mn[curr], depth[ch]);
        } else {
            dfs(ch, curr, d+1);
            mn[curr] = min(mn[curr], mn[ch]);
        }
    }
    if (depth[par] < mn[curr]) {
        roads++;
    }
    //cerr<<"exit "<<curr<<' '<<depth[curr]<<' '<<mn[curr]<<endl;
}

void solve() {
    dfs(0, 0, 0);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}
/*
6 6
1 2
1 3
1 4
4 5
5 6
6 4
*/
