#include<iostream>
#include<cstdio>
#include<vector>
using namespace std;

int n,m;
vector<int>gr[605];
int br;
int low[603],disc[603];
int timer;
bool used[603];

void dfs(int node,int p)
{
	used[node] = true;
	disc[node] = low[node] = timer;
	timer++;
	for(int i = 0; i < gr[node].size();i++)
	{
		int to = gr[node][i];
		if(to == p) continue;
		if(used[to] == true)
		{
			low[node] = min(disc[to],low[node]);//direct
		}
		else
		{
			dfs(to,node);
			low[node] = min(low[node],low[to]);//indirect
			if(low[to] > disc[node] ) br++;
		}
	}
}


int main()
{
	int v1,v2;
	scanf("%d%d",&n,&m);
	for(int i = 0; i < m; i++)
	{
		scanf("%d%d",&v1,&v2);
		gr[v1].push_back(v2);
		gr[v2].push_back(v1);
	}
	dfs(1,-1);
	printf("%d\n",br);
}

/*
9 10
5 1
1 2
2 6
3 4
4 7
6 7
2 5
3 6
7 8
8 9
*/
