#include<iostream>
#include<cstdio>
using namespace std;

int n,m;
int gr[603][603];
pair<int,int> r[2003];
int br;
bool used[603];

void dfs(int node)
{
	used[node] = true;
	for(int i = 1; i <= n; i++)
	{
		if(used[i] == false && gr[node][i] > 0)
		{
			//printf("%d\n",i);
			dfs(i);
		}
	}
}


int main()
{
	int v1,v2;
	scanf("%d%d",&n,&m);
	for(int i = 0; i < m; i++)
	{
		scanf("%d%d",&v1,&v2);
		r[i].first = v1;
		r[i].second = v2;
		gr[v1][v2] = gr[v2][v1] = 1;
	}
	int c;
	for(int i = 0; i < m; i++)
	{
		v1 = r[i].first;
		v2 = r[i].second;
		gr[v1][v2] = gr[v2][v1] = 0;
		c = 0;
		for(int j =1; j <= n; j++)
		{
			if(!used[j])
			{
				dfs(j);
				//printf("%d\n",j);
				c++;
			}
		}
		if(c > 1) br++;
		gr[v1][v2] = gr[v2][v1] = 1;
		for(int l = 1; l <= n; l++) used[l] = false;
	}
	printf("%d\n",br);
}

/*
9 10
5 1
1 2
2 6
3 4
4 7
6 7
2 5
3 6
7 8
8 9
*/
