#include <bits/stdc++.h>

using namespace std;

const int N = 100000 + 3;
const int M = 2000 + 3;

int n, m;
vector<int> adj[N];
bool used[N];
int mn[N], t[N];
int timer;

int find_bridges(int u, int p = -1){
    used[u] = true;
    t[u] = timer++;
    mn[u] = t[u];

    int ans = 0;
    for(int to: adj[u]){
        if(to == p) continue;
        if(used[to]){
            mn[u] = min(mn[u], t[to]);
            continue;
        }

        ans += find_bridges(to, u);
        if(mn[to] > t[u]) ans++;
        mn[u] = min(mn[u], mn[to]);
    }
    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    int ans = 0;
    for(int i = 1; i <= n; ++i)
        if(!used[i])
            ans += find_bridges(i);

    cout << ans << "\n";
}
