#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

int k;
vector <int> sizes;

map <int, int> mp;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> k;
    for(int i = 0;i<k;i++)
    {
        int sz;
        cin >> sz;

        sizes.push_back(sz);
    }

    vector <int> v;
    v.reserve(int(5e5+5));

    for(int sz: sizes)
    {
        v.clear();
        for(int i = 0;i<sz;i++)
        {
            int x;
            cin >> x;

            v.push_back(x);
        }

        sort(v.begin(), v.end());
        for(int i = 0;i<v.size();i++)
        {
            if(i==0 || v[i-1]!=v[i])
                mp[ v[i] ]++;
        }
    }

    for(pair <int, int> x: mp)
    {
        if(x.second==k)
        {
            cout << x.first << '\n';
            return 0;
        }
    }

    cout << "x" << '\n';
}
