#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define see(x) cout<<#x<<"="<<x<<endl;

using namespace std;

int n, m, used[1000];
vector <pair <int, int>> edge;
vector <int> g[1000];

void dfs (int v, int a, int b) {
	used[v] = 1;

	for (auto i: g[v]) {
		if (i == a and v == b) continue;
		if (i == b and v == a) continue;
		if (!used[i]) dfs(i,a,b);
	}
}

int32_t main() {
/*
    #ifndef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
*/
    cin >> n >> m;

    for (int i = 0; i < m; ++ i) {
    	int a, b;
    	cin >> a >> b;
    	edge.push_back({a,b});
    	g[a].push_back(b);
    	g[b].push_back(a);
    }

    int cnt = 0;
    for (auto i: edge) {
    	for (int j = 1; j <= n; ++ j)
    		used[j] = 0;

    	dfs(i.first, i.first, i.second);

    	if (!used[i.second]) cnt ++;
    }

    cout << cnt << endl;

    return 0;
}