#include <iostream>
#include <vector>
#include <map>

using ll = long long;

std::map<int,int> mp;

int main() {
  std::ios::sync_with_stdio(0);
  std::cin.tie(0);

  int n;
  std::cin >> n;
  std::vector<int> v(n);
  for(int i = 0;i < n; i++)
    std::cin >> v[i];
  for(int i = 0; i < n; i++) {
    std::map<int,int> frec;
    for(int j = 0; j < v[i]; j++) {
      int val;
      std::cin >> val;
      if(frec[val] == 0) {
        mp[val]++;
        frec[val] = 1;
      }
    }
  }
  for(std::map<int,int>::iterator it = mp.begin(); it != mp.end(); it++)
    if(n <= it->second) {
      std::cout << it->first;
      return 0;
    }
  std::cout << "x";
  return 0;
}

