#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using ll = long long;

int main() {
  std::ios::sync_with_stdio(0);
  std::cin.tie(0);

  int n;
  std::cin >> n;
  std::vector<int> v(n);
  for(int i = 0;i < n; i++)
    std::cin >> v[i];
  std::vector<int> global;
  for(int i = 0; i < n; i++) {
    std::vector<int> aux;
    for(int j = 0; j < v[i]; j++) {
      int val;
      std::cin >> val;
      aux.push_back(val);
    }
    std::sort(aux.begin(), aux.end());
    aux.erase(std::unique(aux.begin(), aux.end()), aux.end());
    for(int i = 0; i < aux.size(); i++)
      global.push_back(aux[i]);
  }
  std::sort(global.begin(), global.end());
  int last = 0, sum = 0;

  for(int i = 0; i < global.size(); i++) {
    if(last == global[i]) {
      sum++;
    } else {
      last = global[i];
      sum = 1;
    }
    if(n <= sum) {
      std::cout << global[i];
      return 0;
    }
  }
  std::cout << 'x';
  return 0;
}

