#include <iostream>
#include <vector>
#define ii pair<int,int>
#define x first
#define y second
using namespace std;

int count=0;
vector<vector<int>> g;
vector<bool> visited;
vector<int> tin;
vector<int> low;
int timer=0;
void dfs(int i, int from){
    visited[i]=true;
    tin[i]=timer++;
    low[i]=tin[i];
    for(auto u:g[i]){
        if(!visited[u]){
            dfs(u,i);
            if(tin[i]<low[u]){
                count++;
            }
            low[i]=min(low[i],low[u]);
        }
        else if(u!=from){
            low[i]=min(low[i],tin[u]);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    g.resize(n+1);
    for(int i=0; i<m; i++){
        int x,y;
        cin>>x>>y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    visited.assign(n+1,false);
    low.resize(n+1);
    tin.resize(n+1);
    for(int i=1; i<=n ;i++) {
        dfs(1, -1);
    }

    cout<<count;
    return 0;
}
