#include <bits/stdc++.h>

using namespace std;

const int MAXN = 605;
const int MAXM = 2005;

vector<int>G[MAXN];
int u[MAXM], v[MAXM];
bool vis[MAXN];

void dfs(int node) {
  vis[node] = 1;
  for (auto it:G[node])
    if (!vis[it])
      dfs(it);
}

int solve(int n, int m, int k) {
  for (int i = 1; i <= n; ++i) {
    vis[i] = 0;
    G[i].clear();
  }
  for (int i = 1; i <= m; ++i)
    if (i != k) {
      G[u[i]].push_back(v[i]);
      G[v[i]].push_back(u[i]);
    }
  dfs(u[k]);
  return !vis[v[k]];
}

int main() {
  //freopen("date.in", "r", stdin);
  //freopen("date.out", "w", stdout);

  int n, m;
  scanf("%d%d", &n, &m);
  for (int i = 1; i <= m; ++i)
    scanf("%d%d", &u[i], &v[i]);

  int ans = 0;
  for (int i = 1; i <= m; ++i)
    ans += solve(n, m, i);

  printf("%d\n", ans);

  return 0;
}
