#include<bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pb push_back
#define ld long double
#define endl '\n'

int n, m;

vector < set < int > > G;

vector < bool > use;

void dfs(int v){
    use[v] = 1;
    for (auto to : G[v]){
        if (!use[to])dfs(to);
    }
}

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    int ans = 0;
    G.resize(n);
    vector < pair < int, int > > a(m);
    for (int i = 0;i < m; ++i){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        G[x].insert(y);
        G[y].insert(x);
        a[i] = {x, y};
    }
    use.resize(n, 0);
    for (int i = 0;i < m; ++i){
        int x = a[i].F;
        int y = a[i].S;
        G[x].erase(G[x].find(y));
        G[y].erase(G[y].find(x));
        dfs(x);
        if (!use[y])ans++;
        G[x].insert(y);
        G[y].insert(x);
        fill(use.begin(), use.end(), 0);
    }
    cout << ans << endl;
    return 0;
}
