#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, m;
vector< vector<int> > adj;

vector<int> used, tin, fup;
int mytm = 1;

vector< pair<int, int> > bridges;

void dfs(int u, int p) {
	tin[u] = mytm++;
	fup[u] = tin[u];
	used[u] = 1;
	for(int v: adj[u]) {
		if(used[v] == 2 || v == p) {
			continue;
		}
		if(used[v] == 1) {
			fup[u] = min(fup[u], tin[v]);
		} else {
			dfs(v, u);
			fup[u] = min(fup[u], fup[v]);
			if(fup[v] >= tin[v]) {
				bridges.emplace_back(min(u, v), max(u, v));
			}
		}
	}
	used[u] = 2;
}

signed main() {
	cin >> n >> m;

	adj.resize(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		adj[u].push_back(v);
		adj[v].push_back(u);
	}

	used.resize(n);
	tin.resize(n);
	fup.resize(n);
	for(int i = 0; i < n; i++) {
		if(!used[i]) {
			dfs(i, -1);
		}
	}

	sort(bridges.begin(), bridges.end());

	cout << unique(bridges.begin(), bridges.end()) - bridges.begin() << endl;

	return 0;
}