#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <queue>
#include <set>
#include <map>
using namespace std;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
    return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(a)
#endif
using llong = long long;
using uint = unsigned int;
using ullong = unsigned long long;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
const int maxN = 100'005;
const int maxK = 460;

vector<int> nei[maxN];
int sz[maxN];
bool inComp[maxN];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int k;
    cin >> k;
    vector<int> len(k);
    for (int& n: len) cin >> n;
    map<int, int> cnt;
    vector<int> b;
    for (int i = 0; i < k; ++i)
    {
        b.resize(len[i]);
        for (int& j: b)
            cin >> j;
        sort(b.begin(), b.end());
        for (int j = 0; j < b.size(); ++j)
            if (!j || b[j] != b[j - 1])
                ++cnt[b[j]];
    }
    bool ansed = false;
    for (auto p: cnt)
        if (p.second == k) {
            cout << p.first;
            ansed = true;
            break;
        }
    if (!ansed)
        cout << 'x';
}
