#include<bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);
#define fileio freopen("avia.in", "r", stdin); freopen("avia.out", "w", stdout);

vector<int> tin;
vector<int> fup;
vector<set<int>> g;
vector<bool> used;
int timer = 0;
set<pair<int, int>> a;

void dfs(int v, int p) {
    tin[v] = ++timer;
    fup[v] = tin[v];
    used[v] = true;
    for (int u : g[v]) {
        if (u == p) continue;
        if (!used[u]) {
            dfs(u, v);
            fup[v] = min(fup[u], fup[v]);
        } else {
            fup[v] = min(fup[v], tin[u]);
        }
    }
    if (p != -1 && fup[v] > tin[p]) a.insert({p, v});
}

signed main() {
    fastio
//    fileio
    int n, m;
    cin >> n >> m;
    g.resize(n);
    set<pair<int, int>> b;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;--v;--u;
        if (g[v].count(u)) {
            b.insert({v, u});
            b.insert({u, v});
        } else {
            g[v].insert(u);
            g[u].insert(v);
        }
    }
    used.resize(n);
    tin.resize(n);
    fup.resize(n);
    for (int v = 0; v < n; ++v) {
        if (!used[v]) dfs(v, -1);
    }
    int cnt = 0;
    for (auto p : a) {
        if (!b.count(p)) ++cnt;
    }
    cout << cnt;
}
