#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define MN 1000000000
#define pb push_back

using namespace std;

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n,m;
    cin>>n>>m;

    pair<int,int> pat[m];
    vector<pair<int,int>> patAcc[n];

    for (int i = 0; i<m; i++) {
        int a,b;
        cin>>a>>b;
        a--; b--;

        pat[i] = {a,b};
        patAcc[a].pb({b,i});
        patAcc[b].pb({a,i});
    }

    int res = 0;

    for (int i = 0; i<m; i++) {
        /// i = forbiden

        queue<int> qI;
        qI.push(0);

        bool vis[n];
        MS(vis, 0);
        vis[0] = true;

        while (!qI.empty()) {
            int curr = qI.front();

            qI.pop();

            for (auto it:patAcc[curr]) {
                if (it.second == i) continue;
                if (vis[it.first]) continue;

                vis[it.first] = true;
                qI.push(it.first);
            }
        }

        bool check = true;

        for (int j = 0; j<n; j++) if (vis[j] == false) check = false;

        if (check) res++;
    }

    cout<<res<<endl;
}
