#include <vector>
#include <iostream>
using namespace std;


vector<vector<pair<int, int>>> adj;
bool done[600];
int n, m;

void chack(int x, int no) {
    if (done[x])
        return;
    done[x] = true;
    for (auto u : adj[x]) {
        if (u.second != no && !done[u.first]) {
            chack(u.first, no);
        }
    }
}

int main()
{
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        adj.push_back(vector<pair<int, int>>());
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        adj[a - 1].push_back({ b - 1, i });
        adj[b - 1].push_back({ a - 1, i });
    }
    int count = 0;
    for (int i = 0; i < m; i++) {
        chack(0, i);
        bool f = false;
        for (int j = 0; j < n; j++) {
            if (done[j] == false)
                f = true;
            done[j] = false;
        }
        if (f)
            count++;
    }
    cout << count << endl;
}
