#include <iostream>
#include <map>
#include <stack>
#include <climits>
using namespace std;



map<int, int> m;
int lens[1000];

int main() {
	cin.tie(0);
	ios::sync_with_stdio(false);
	int k;
	cin >> k;
	for (int i = 0; i < k; i++) {
		cin>>lens[i];
	}
	map<int, bool> done;
	stack<int> s;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < lens[i]; j++) {
			int a;
			cin >> a;
			s.push(a);
			if (!done[a])
			{
				done[a] = true;
				m[a] ++;
			}
		}
		while (!s.empty()) {
			done[s.top()] = false;
			s.pop();
		}
	}
	int ans = INT_MAX;
	for (map<int, int>::iterator i = m.begin(); i != m.end(); i++) {
		if (i->second == k && i->first < ans) {
			ans = i->first;
		}
	}
	if (ans == INT_MAX)
		cout << "x" << endl;
	else
		cout << ans << endl;


}