#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

const int N = 6e2 + 10;

vector<pair<int, int>> g[N];
int fup[N], t[N];
int timer = 1;
int cnt = 0;

void dfs(int u, int p = -1) {
	fup[u] = t[u] = timer++;
	for (auto e : g[u]) {
		if (e.y == p)
			continue;
		int v = e.x;
		if (t[v]) {
			fup[u] = min(fup[u], t[v]);
		} else {
			dfs(v, e.y);
			if (fup[v] > fup[u])
				++cnt;
			fup[u] = min(fup[u], fup[v]);
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[--u].push_back({--v, i});
		g[v].push_back({u, i});
	}
	for (int i = 0; i < n; ++i)
		if (!t[i])
			dfs(i);
	cout << cnt;
	return 0;
}