#include <bits/stdc++.h>

using namespace std;


#define fi first
#define se second
#define pb push_back
#define rep(i, n) for(int i = 0; i < n; ++i)

typedef long long int ll;
typedef vector<int> vi;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<ll> vl;



const int maxn = 605;
const int maxm = 2005;


vi g[maxn];
bitset<maxn> vis = 0;
vector<pi> edges;
int cr[maxn];
int csz[maxn];
int cid[maxn];
void dfs1(int c, int compid)
{
    cid[c] = compid;
    vis[c] = 1;
    csz[compid]++;
    for(auto e : g[c])
    {
        int other = edges[e].fi == c ? edges[e].se : edges[e].fi;
        if(!vis[other])
        {
            dfs1(other, compid);
        }

    }
}

signed main()
{


    // it is not given that the graph is connected
    ios::sync_with_stdio(false); cin.tie(nullptr);
    int n, m; cin >> n >> m;
    rep(i, m)
    {
        int s, t; cin >> s >> t; g[s].pb(i); g[t].pb(i);
        edges.emplace_back(s, t);
    }

    int not_allowed = 0;
    function<int(int)> dfs = [&] (int c) -> int {
        vis[c] = 1;
        int res = 1;
        for(auto e : g[c])
        {
            if(e != not_allowed) {
                int other = edges[e].fi == c ? edges[e].se : edges[e].fi;
                if(!vis[other])
                {
                    res += dfs(other);
                }
            }
        }
        return res;
    };

    int nid = -1;
    for(int i = 1; i <= n; ++i)
    {
        if(!vis[i])
        {
            dfs1(i, ++nid);
            cr[nid] = i;
        }
    }
    int out = 0;
    for(; not_allowed < m; not_allowed++)
    {
        int r = cid[ edges[not_allowed].fi ];
        vis = 0;
        if(dfs(cr[r]) != csz[r]) out++;
    }
    cout << out << '\n';

}