#include <bits/stdc++.h>
using namespace std;

const int N = (int)(1e2);

int n, m, ans;
int dp[N], depth[N];
bool was[N];
vector <int> g[N];

void dfs(int v, int pr = -1) {
    if (was[v]) {
        return;
    }
    dp[v] = depth[v];
    for (int u : g[v]) {
        if (u == pr) {
            continue;
        }
        if (was[u]) {
            dp[v] = min(depth[u], dp[v]);
        } else {
            dfs(u, v);
            dp[v] = min(dp[v], dp[u]);

            ans += (dp[u] >= depth[v]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 0; i < n; ++i) {
        dfs(i);
    }

    cout << ans << "\n";
}
