#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

#define pb push_back

using namespace std;

using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

const int N = 1e4 + 34;

int rx[8] = {-1, -1, 1, 1, -2, -2, 2, 2};
int ry[8] = {-2, 2, -2, 2, -1, 1, -1, 1};

vector < int > g[N];

int ans = 0;

int tin[N], up[N], timer;

bool u[N];

void dfs(int v, int p = -1) {
    tin[v] = up[v] = timer++;
    u[v] = 1;
    for (auto to : g[v]) {
        if (to == p) {
            continue;
        }
        if (!u[to]) {
            dfs(to, v);
        }
        up[v] = min(up[v], up[to]);
        if (up[to] > tin[v]) {
            ++ans;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    int x, y;
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        --x;
        --y;
        g[x].pb(y);
        g[y].pb(x);
    }
    for (int i = 0; i < n; ++i) {
        if (!u[i]) {
            dfs(i);
        }
    }
//    for (int i = 0; i < n; ++i) {
//        cout << tin[i] << ' ' << up[i] << endl;
//    }
    cout << ans;
    return 0;
}
