#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 5;

vector<vector<int>> g(MAXN);

int used[MAXN];
int tin[MAXN];
int fup[MAXN];

int ans = 0;
int timer = 0;

void dfs(int u, int pr)
{
    tin[u] = fup[u] = timer++;
    used[u] = true;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            dfs(v, u);
            fup[u] = min(fup[u], fup[v]);
            if (fup[v] > tin[u])
            {
                ++ans;
            }
        }
        else if (v != pr)
        {
            fup[u] = min(fup[u], tin[v]);
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, -1);
    cout << ans << endl;
    return 0;
}
