#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector <int> g[602];
int used[602], tin[602], fup[602];
int cnt = 0;
int timer;
void dfs(int i, int p)
{
	used[i] = 1;
	tin[i] = fup[i] = timer++;
	for (auto to: g[i])
		if (to != p)
		{
			if (used[to])
				fup[i] = min(tin[to], fup[i]);
			else
			{
				dfs(to, i);
				fup[i] = min(fup[i], fup[to]);
				if (fup[to] > tin[i])cnt++;
			}
		}
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 0; i < n; i++)
		if (used[i] != 1)
			dfs(i, -1);
	cout << cnt;
	return 0;
}