//#include <bits/stdc++.h>
#include "cstdio"
#include "math.h"
#include "vector"
#include "algorithm"
#include "set"
#include "map"
#include "stack"
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>
#include <cstring>
#include <unordered_map>

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

using ll = long long;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pli pair<ll, int>
#define pb push_back
#define ld long double
#define pdd pair<double, double>
#define mp make_pair
//#define f first
//#define s second

mt19937 gen(time(0));

void setIO(string name = "") {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
//    freopen((name+".in").c_str(), "r", stdin);
//    freopen((name+".out").c_str(), "w", stdout);
}

const int MAXN = 605;

vector<vector<int>> graph(MAXN, vector<int> ());
vector<set<int>> already(MAXN, set<int> ());
vector<set<int>> denyed(MAXN, set<int> ());
vector<int> tin(MAXN, -1);
vector<int> fup(MAXN);
int timer = 0, cnt = 0;

void dfs(int v, int p) {
    tin[v] = fup[v] = timer++;
    for (int u : graph[v]) {
        if (u == p) continue;
        if (tin[u] == -1) {
            dfs(u, v);
            fup[v] = min(fup[v], fup[u]);
            if (fup[u] > tin[v] && !denyed[v].count(u)) {
                cnt++;
            }
        } else {
            fup[v] = min(fup[v], tin[u]);
        }
    }
}

int main() {
//    ifstream in;
//    ofstream out;
//    in.open("sysadmin.in");
//    out.open("sysadmin.out");
    setIO();
    int n, m, v, u;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> v >> u;
        v--, u--;
        graph[v].pb(u);
        graph[u].pb(v);
        if (already[v].count(u)) {
            denyed[v].insert(u);
            denyed[u].insert(v);
        }
        already[v].insert(u);
        already[u].insert(v);
    }
    for (int i = 0; i < n; i++) {
        if (tin[i] != -1) continue;
        dfs(0, -1);
    }
    cout << cnt;
    return 0;
}