#define _CRT_SECURE_NO_WARNINGS
#define fast ios::sync_with_stdio(false); cin.tie(0)
#define foru(i, k, n) for (int i = k; i < n; i++)
#define ford(i, k, n) for (int i = k; i >= n; i--)
#define pb push_back
#define mp make_pair

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <list>
#include <iomanip>
#include <numeric>
#include <bitset>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<vector<ll>> mat;

const int sz = 500;
vector<pii> adj[sz];
int n, m, bad = -1;
bitset<sz> vis;
vector<pii> e;

void dfs(int src) {
	vis[src] = 1;
	for (pii x : adj[src]) {
		if (x.second != bad and not vis[x.first])dfs(x.first);
	}
}

int main() {
	fast;
	cin >> n >> m;
	foru(i, 0, m) {
		int a, b;
		cin >> a >> b; 
		adj[--a].pb({ --b,i });
		adj[b].pb({ a,i });
		e.pb({ a,b });
	}
	int ret = 0;
	for (int i = 0; i < m; i++) {
		bad = i;
		vis.reset();
		dfs(e[i].first);
		ret += (!e[i].second);
	}
	cout << ret << '\n';
	return 0;
}