#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ld long double
#define ll long long
#define pb push_back
#define sz(a) a.size()
#define endl '\n'
//#define int long long

const int N = 1e5 + 100;
const int inf = 1e9 + 7;

vector < int > g[N];
int x[N], y[N], u[N];

void DFS(int v, int x, int y)
{
    u[v] = 1;
    for(auto to: g[v])
    {
        if (x == v && y == to) continue;
        if (y == v && x == to) continue;
        if (u[to]) continue;
        DFS(to, x, y);
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        cin >> x[i] >> y[i];
        x[i]--; y[i]--;
        g[x[i]].pb(y[i]);
        g[y[i]].pb(x[i]);
    }
    int ans = 0;
    for(int i = 0; i < m; i++)
    {
        for(int j = 0; j < n; j++)
        {
            u[j] = 0;
        }
        int cnt = 0;
        for(int j = 0; j < n; j++)
        {
            if (!u[j]) 
            {
                cnt++;
                DFS(j, x[i], y[i]);
            }
        }
        if (cnt > 1) ans++;
    }
    cout << ans;
}
