#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e3;
vector<int> g[MAXN];
int d[MAXN], up[MAXN], used[MAXN];
int cnt = 0;

void dfs(int v, int p = -1) {
    used[v] = true;
    up[v] = d[v];
    for (auto u : g[v]) {
        if (!used[u]) {
            d[u] = d[v] + 1;
            dfs(u, v);
            up[v] = min(up[v], up[u]);
        } else if (u != p) {
            up[v] = min(up[v], d[u]);
        }
    }
    if (up[v] == d[v] && p != -1) {
        cnt++;
    }
}

main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            d[i] = 0;
            dfs(i);
        }
    }
    cout << cnt;
    return 0;
}
