#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a.begin()), (a.end())
#define endl "\n"
#pragma GCC optimize('O3')

using namespace std;

const int N = 1e6 + 10;
const int inf = 1e10;

int n;
int a[N];
map<int, int> mp;

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n;

	for (int i = 0; i < n; ++i)
		cin >> a[i];

	for (int i = 0; i < n; ++i)
	{
		vector<int> v(a[i]);

		for (int j = 0; j < a[i]; ++j)
			cin >> v[j];

		sort(all(v));
		v.resize(unique(all(v)) - v.begin());
		
		for (auto it : v)
			++mp[it];
	}

	int ans = inf;

	for (const auto &p : mp)
		if (p.y == n)
			ans = min(ans, p.x);

	if (ans == inf)
		cout << "x" << endl;
	else
		cout << ans << endl;
}

