#include <bits/stdc++.h>
#define pb push_back
using namespace std;
const int nax = 605;
bool seen[nax];
int n, m;
int deg[nax];
vector<int> E[nax];
vector<pair<int,int>> e;
int ans = 0;
void dfs(int node, int x, int y) {
    seen[node] = true;
    for(auto it : E[node]) {
        if(node == x && it == y) continue;
        if(!seen[it]) {
            dfs(it, x, y);
        }
    }
}
int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    for(int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        E[x].pb(y);
        E[y].pb(x);
        e.pb({x, y});
    }

    for(auto it : e) {
        for(int i = 1; i <= n; i++) {
            seen[i] = false;
        }
        dfs(it.first, it.first, it.second);
        if(seen[it.second] == false) ans++;
    }
    cout << ans << '\n';
    return 0;
}
