#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 601
using namespace std;
int n, m;

struct node
{
    int ver, id;
    node (int _ver, int _id)
    {
        ver = _ver;
        id = _id;
    }
};

struct edge
{
    int from, to, id;
    edge (int _from, int _to, int _id)
    {
        from = _from;
        to = _to;
        id = _id;
    }
};

vector <node> adj[MAXN];
vector <edge> edges;

void input()
{
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
    {
        int from, to;
        cin >> from >> to;
        adj[from].push_back(node(to, i));
        adj[to].push_back(node(from, i));
        edges.push_back(edge(from, to, i));
    }
}

bool used[MAXN];

void dfs(int tmp, int ban)
{
    used[tmp] = 1;
    for (auto nb: adj[tmp])
    {
        if (used[nb.ver] || nb.id == ban)
            continue;
        dfs(nb.ver, ban);
    }
}

void solve()
{
    int cnt = 0;
    for (auto curr: edges)
    {
        for (int i = 0; i <= n; ++i)
            used[i] = 0;
        int id = curr.id;
        int from = curr.from;
        int to = curr.to;
        dfs(from, id);
        if (!used[to])
            ++cnt;
    }

    cout << cnt << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
