#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) idx&(-idx)
#define bin(x) bitset<32>(x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x)  -> how many elements are smaller than x
/// insert(x) -> inserts x into the set

ll n, m, ans;
matrix G;
row used;
vector<pair<ll, ll>> edges;

void dfs(ll u, ll s, ll e){
	used[u] = true;
	for(auto v : G[u]){
		if(!((u == e && v == s) || (u == s && v == e)) && !used[v]){
			dfs(v, s, e);
		}
	}
}

int main(){
	/// ios_base::sync_with_stdio(false); cin.tie(NULL);
	cin >> n >> m;
	G = matrix(n + 1);
	for(int i = 0; i < m; i ++){
		int u, v; cin >> u >> v;
		G[u].pb(v);
		G[v].pb(u);
		edges.pb({u, v});
	}
	for(auto [u, v] : edges){
		used = row(n + 1, 0);
		dfs(u, u, v);
		ll cnt = 0;
		for(int u = 1; u <= n; u ++){
			if(used[u]){
				++ cnt;
			}
		}
		if(cnt != 0){
			++ ans;
		}
	}
	cout << ans << endl;
}
/**
7 8
5 1
1 2
2 6
3 4
4 7
6 7
2 5
3 6
*/