#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int k;
vector<int> lengths;
vector<set<int>> sequences;

void read() {
    cin >> k;

    lengths.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> lengths[i];
    }

    sequences.resize(k);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < lengths[i]; j++) {
            int value;
            cin >> value;

            sequences[i].emplace(value);
        }
    }
}

void solve() {
    for (int val : sequences[0]) {
        bool ok = true;

        for (int i = 1; i < k; i++) {
            if (sequences[i].find(val) == sequences[i].end()) {
                ok = false;
                break;
            }
        }

        if (ok) {
            cout << val << endl;
            return;
        }
    }

    cout << "x\n";
}

int main() {
    setIO();

    read();

    solve();
}
